import math
import sys
import random
from typing import List

def radixsort2(lst: List[int], P: List[int]) -> List[int]:
    n = len(lst)
    k = math.floor(math.log(max(P), 2))

    if not k&1: P = [n-1-i for i in P]
    for bit in range(k+1):
        lst0 = []
        lst1 = []
        for i in lst:
            if ((P[i] >> bit) ^ bit) & 1:
                lst1.append(i)
                print('move', 0, 2)
            else:
                lst0.append(i)
                print('move', 0, 1)
        lst = lst0 + lst1
        lst.reverse()
        
        print('transfer', 1, 0)
        print('transfer', 2, 0)
    return lst

if len(sys.argv) != 2:
    print(f'Usage:\n  {sys.argv[0]} <n>')
    sys.exit(1)
    
n = int(sys.argv[1])

lst = list(range(n))
P   = list(range(n))
random.shuffle(P)
lst = radixsort2(lst, P)
assert all(it == P[i] for it, i in enumerate(lst))
